Use Cases for MPLS Network Action Indicators and MPLS Ancillary Data
Tarek Saad
Cisco Systems, Inc.
tsaad.net@gmail.com
Kiran Makhijani
Independent
kiran.ietf@gmail.com
Haoyu Song
Futurewei Technologies
haoyu.song@futurewei.com
Greg Mirsky
Ericsson
gregimirsky@gmail.com
2024
MPLS Working Group
Internet-Draft
This document presents use cases that have a common feature in that they may be addressed by encoding network action indicators and associated ancillary data within MPLS packets. There are interest in extending the MPLS data plane to carry such indicators and ancillary data to address the use cases that are described in this document.
The use cases described in this document are not an exhaustive set, but rather the ones that are actively discussed by members of the IETF MPLS, PALS, and DetNet working groups.
Introduction
This document describes cases that introduce functions that are based on special processing by forwarding hardware. Previously, that required the allocation of a new special-purpose label or extended special-purpose label. To conserve that limited resource, an MPLS Network Action (MNA) approach was introduced to extend the MPLS architecture. MNA is expected to enable functions that may require carrying additional ancillary data within the MPLS packets, as well as means to indicate the ancillary data is present and a specific action needs to be performed on the packet.
This document lists various use cases that could benefit extensively from the MNA framework [I-D.ietf-mpls-mna-fwk]. Supporting a solution of the general MNA framework provides a common foundation for future network actions that can be exercised in the MPLS data plane.
Terminology
The following terminology is used in the document:
RFC 9543 Network Slice
is interpreted as defined in [RFC9543]. Furthermore, in this document, the term "network slice" is used interchangeably as a shorter version of RFC 9543 Network Slice term.
The MPLS Ancillary Data (AD) classified as:
- residing within the MPLS label stack and referred to as In Stack Data (ISD), and
- residing after the Bottom of Stack (BoS) and referred to as Post Stack Data (PSD).
Conventions used in this document
Acronyms and Abbreviations
- ISD: In-stack data
- PSD: Post-stack data
- MNA: MPLS Network Action
- NAI: Network Action Indicator
- AD: Ancillary Data
- DEX: Direct Export
- GDF: Generic Delivery Function
- I2E: Ingress to Edge
- HbH: Hop by Hop
- PW: Pseudowire
- BoS: Bottom of Stack
- ToS: Top of Stack
- NSH: Network Service Header
- FRR: Fast Reroute
- IOAM: In-situ Operations, Administration, and Mantenance
- G-ACh: Generic Associated Channel
- LSP: Label Switched Path
- LSR: Label Switch Router
- NRP: Network Resource Partition
- AMM: Alternative Marking Method
Use Cases
No Further Fastreroute
MPLS Fast Reroute [RFC4090], [RFC5286] and [RFC7490] is a useful and widely deployed tool for minimizing packet loss in the case of a link or node failure.
Several cases exist where, once a Fast Reroute (FRR) has taken place in an MPLS network and resulted in rerouting a packet away from the failure, a second FRR impacts the same packet on another node, and may result in traffic disruption.
In such a case, the packet impacted by multiple FRR events may continue to loop between the label switch routers (LSRs) that activated FRR until the packet's TTL expires. This can lead to link congestion and further packet loss. To avoid that situation, packets that have been redirected by FRR will be marked using MNA to preclude further FRR processing.
Applicability of Hybrid Measurement Methods
MNA can be used to carry information essential for collecting operational information and measuring various performance metrics that reflect the experience of the packet marked by MNA. Optionally, the operational state and telemetry information collected on the LSR may be transported using MNA techniques.
In-situ OAM
In-situ Operations, Administration, and Maintenance (IOAM), defined in [RFC9197] and [RFC9326], might be used to collect operational and telemetry information while a packet traverses a particular path in a network domain.
IOAM can run in two modes: Ingress to Edge (I2E) and Hop by Hop (HbH). In I2E mode, only the encapsulating and decapsulating nodes will process IOAM data fields. In HbH mode, the encapsulating and decapsulating nodes, as well as intermediate IOAM-capable nodes, process IOAM data fields. The IOAM data fields, defined in [RFC9197], can be used to derive the operational state of the network experienced by the packet with the IOAM Header that traversed the path through the IOAM domain.
Several IOAM Option-Types have been defined:
- Pre-allocated Trace
- Incremental Trace
- Edge-to-Edge
- Proof-of-Transit
- Direct Export (DEX)
With all IOAM Option-Types except for the Direct Export (DEX), the collected information is transported in the trigger IOAM packet. In the IOAM DEX Option [RFC9326], the operational state and telemetry information are collected according to a specified profile and exported in a manner and format defined by a local policy. In IOAM DEX, the user data packet is only used to trigger the IOAM data to be directly exported or locally aggregated without being carried in the IOAM trigger packets.
Alternate Marking Method
The Alternate Marking Method (AMM), defined in [RFC9341] and [RFC9342]) is an example of a hybrid performance measurement method ([RFC7799]) that can be used in the MPLS network to measure packet loss and packet delay performance metrics. [RFC8957] defined the Synonymous Flow Label framework to realize AMM in the MPLS network. The MNA is an alternative mechanism that can be used to support AMM in the MPLS network.
Network Slicing
An RFC 9543 Network Slice service ([RFC9543]) provides connectivity coupled with a set of network resource commitments and is expressed in terms of one or more connectivity constructs. [RFC9543] also defines a Network Resource Partition (NRP) Policy as a policy construct that enables the instantiation of mechanisms to support one or more network slice services. The packets associated with an NRP may carry a marking in their network layer header to identify this association, which is referred to as an NRP Selector. The NRP Selector is used to map a packet to the associated set of network resources and provide the corresponding forwarding treatment onto the packet.
A router that requires the forwarding of a packet that belongs to an NRP may have to decide on the forwarding action to take based on selected next-hop(s), and the forwarding treatment (e.g., scheduling and drop policy) to enforce based on the associated per-hop behavior.
In this case, routers that forward traffic over a physical link shared by multiple NRPs need to identify the NRP to which the packet belongs to enforce their respective forwarding actions and treatments.
MNA technologies can be used to signal actions for MPLS packets and carry data essential for these actions. For example, MNA can carry the NRP Selector [I-D.ietf-teas-ns-ip-mpls] in MPLS packets.
NSH-based Service Function Chaining
[RFC8595] describes how Service Function Chaining can be realized in an MPLS network by emulating the Network Service Header (NSH) using only MPLS label stack elements.
The approach in [RFC8595] introduces some limitations that are discussed in [I-D.lm-mpls-sfc-path-verification]. This approach, however, can benefit from the framework introduced with MNA in [I-D.ietf-mpls-mna-fwk].
MNA can be used to extend NSH emulation using MPLS labels [RFC8595] to support the functionality of NSH Context Headers, whether fixed or variable-length. For example, MNA could support Flow ID [RFC9263] that may be used for load-balancing among Service Function Forwarders and/or the Service Functions within the same Service Function Path.
Network Programming
In Segment Routing (SR), an ingress node steers a packet through an ordered list of instructions called "segments". Each one of these instructions represents a function to be called at a specific location in the network. A function is locally defined on the node where it is executed and may range from simply moving forward in the segment list to any complex user-defined behavior.
Network Programming combines SR functions to achieve a networking objective that goes beyond mere packet routing.
Encoding a pointer to a function and its arguments within an MPLS packet transport header may be desirable. MNA can be used to encode the FUNC::ARGs to support the functional equivalent of FUNC::ARG in SRv6 as described in [RFC8986].
Existing MPLS Use cases
There are several services that can be transported over MPLS networks today. These include providing Layer-3 (L3) connectivity (e.g., for unicast and multicast L3 services), and Layer-2 (L2) connectivity (e.g., for unicast Pseudowires (PWs), multicast E-Tree, and broadcast E-LAN L2 services). In those cases, the user service traffic is encapsulated as the payload in MPLS packets.
For L2 service traffic, it is possible to use Control Word (CW) [RFC4385] and [RFC5085] immediately after the MPLS header to disambiguate the type of MPLS payload, prevent possible packet misordering, and allow for fragmentation. In this case, the first nibble the data that immediately follows after the MPLS BoS is set to 0000b to identify the presence of PW CW.
In addition to providing connectivity to user traffic, MPLS may also transport OAM data (e.g., over MPLS Generic Associated Channels (G-AChs) [RFC5586]). In this case, the first nibble of the data that immediately follows after the MPLS BoS is set to 0001b. It indicates the presence of a control channel associated witha PW, LSP, or Section.
Bit Index Explicit Replication (BIER) [RFC8296] traffic can also be encapsulated over MPLS. In this case, BIER has defined 0101b as the value for the first nibble in the data that immediately appears after the bottom of the label stack for any BIER encapsulated packet over MPLS.
For pseudowires, the Generic Associated Channel [RFC7212] uses the first four bits of the PW control word to provide the initial discrimination between data packets and packets belonging to the associated channel, as described in [RFC4385].
MPLS can be used as the data plane for DetNet [RFC8655]. The DetNet sub-layers, forwarding and service, are realized using the MPLS label stack, the DetNet Control Word [RFC8964] and DetNet Associated Channel Header [RFC9546].
It is expected that new use cases described in this document will allow for the co-existance and backward compatibility with all such existing MPLS services.
Co-existence of the MNA Use Cases
Two or more of the aforementioned use cases may co-exist in the same packet. This may require the presence of multiple ancilary data (whether In-stack or Post-stack ancillary data) to be present in the same MPLS packet.
For example, IOAM may provide key functions along with network slicing to help ensure that critical network slice SLOs are being met by the network provider. In this case, IOAM is able to collect key performance measurement parameters of network slice traffic flow as it traverses the transport network.
IANA Considerations
This document has no IANA actions.
Security Considerations
This document introduces no new security considerations.
Acknowledgement
The authors gratefully acknowledge the input of the members of the MPLS Open Design Team. Also, the authors sicerely thank Loa Andersson, Xiao Min, and Jie Dong for thier thoughtful suggestions and help in improving the document.
References

Informative References
[I-D.ietf-mpls-mna-fwk]
[RFC9543]
[RFC4090]
[RFC5286]
[RFC7490]
[RFC9197]
[RFC9326]
[RFC9341]
[RFC9342]
[RFC7799]
[RFC8957]
[I-D.ietf-teas-ns-ip-mpls]
[RFC8595]
[I-D.lm-mpls-sfc-path-verification]
[RFC9263]
[RFC8986]
[RFC4385]
[RFC5085]
[RFC5586]
[RFC8296]
[RFC7212]
[RFC8655]
[RFC8964]
[RFC9546]
[I-D.zzhang-intarea-generic-delivery-functions]
[I-D.stein-srtsn]
Use Cases for Continued Discussion
A number of use cases for which MNA can provide a viable solution have been brought up. The discussion of these aspirational cases is ongoing.
Generic Delivery Functions
The Generic Delivery Functions (GDFs), defined in [I-D.zzhang-intarea-generic-delivery-functions], provide a new mechanism to support functions analogous to those supported through the IPv6 Extension Headers mechanism. For example, GDF can support fragmentation/reassembly functionality in the MPLS network by using the Generic Fragmentation Header. MNA can support GDF by placing a GDF header in an MPLS packet within the Post-Stack Data block [I-D.ietf-mpls-mna-fwk]. Multiple GDF headers can also be present in the same MPLS packet organized as a list of headers.
Delay Budgets for Time-Bound Applications
The routers in a network can perform two distinct functions on incoming packets, namely forwarding (where the packet should be sent) and scheduling (when the packet should be sent). IEEE-802.1 Time Sensitive Networking (TSN) and Deterministic Networking provide several mechanisms for scheduling under the assumption that routers are time-synchronized. The most effective mechanisms for delay minimization involve per-flow resource allocation.
Segment Routing (SR) is a forwarding paradigm that allows encoding forwarding instructions in the packet in a stack data structure rather than being programmed into the routers. The SR instructions are contained within a packet in the form of a First-in First-out stack dictating the forwarding decisions of successive routers. Segment routing may be used to choose a path sufficiently short to be capable of providing a bounded end-to-end latency but does not influence the queueing of individual packets in each router along that path.
When carried over the MPLS data plane, a solution is required to enable the delivery of such packets that can be delivered to their final destination within a given time budget. One approach to address this use case in SR-MPLS was described in [I-D.stein-srtsn].
Stack-Based Methods for Latency Control
One efficient data structure for inserting local deadlines into the headers is a "stack", similar to that used in Segment Routing to carry forwarding instructions. The number of deadline values in the stack equals the number of routers the packet needs to traverse in the network, and each deadline value corresponds to a specific router. The Top-of-Stack (ToS) corresponds to the first router's deadline, while the MPLS BoS refers to the last. All local deadlines in the stack are later or equal to the current time (upon which all routers agree), and times closer to the ToS are always earlier or equal to times closer to the MPLS BoS.
The ingress router inserts the deadline stack into the packet headers; no other router needs to be aware of the requirements of the time-bound flows. Hence, admitting a new flow only requires updating the information base of the ingress router.
MPLS LSRs that expose the ToS label can also inspect the associated "deadline" carried in the packet (either in the MPLS stack as ISD or after BoS as PSD).
Contributors' Addresses
Loa Anderssen
Bronze Dragon Consulting
loa@pi.nu